//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbcreaVtkHausdorffDistancePointSetFilter_h_INCLUDED__
#define __bbcreaVtkHausdorffDistancePointSetFilter_h_INCLUDED__

#include "bbcreaVtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include <vtkPolyData.h>

namespace bbcreaVtk
{

class bbcreaVtk_EXPORT HausdorffDistancePointSetFilter
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(HausdorffDistancePointSetFilter,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
  BBTK_DECLARE_INPUT(InA,vtkPolyData*);
  BBTK_DECLARE_INPUT(InB,vtkPolyData*);

  BBTK_DECLARE_OUTPUT(RelativeDistanceAtoB,double);
  BBTK_DECLARE_OUTPUT(RelativeDistanceBtoA,double);
  BBTK_DECLARE_OUTPUT(HausdorffDistance,double);
  BBTK_DECLARE_OUTPUT(OutA,vtkPolyData*);
  BBTK_DECLARE_OUTPUT(OutB,vtkPolyData*);
  
  BBTK_PROCESS(Process);
  void Process();
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(HausdorffDistancePointSetFilter,bbtk::AtomicBlackBox);
  BBTK_NAME("HausdorffDistancePointSetFilter");
  BBTK_AUTHOR("InfoDev");
  BBTK_DESCRIPTION("Output Mesh with HausdorffDistance and RelativeDistance vector information ");
  BBTK_CATEGORY("empty");

  BBTK_INPUT(HausdorffDistancePointSetFilter,InA,"Mesh A",vtkPolyData*,"");
  BBTK_INPUT(HausdorffDistancePointSetFilter,InB,"Mesh B",vtkPolyData*,"");

  BBTK_OUTPUT(HausdorffDistancePointSetFilter,RelativeDistanceAtoB,"Relative distance A to B",double,"");
  BBTK_OUTPUT(HausdorffDistancePointSetFilter,RelativeDistanceBtoA,"Relative distance B to A",double,"");
  BBTK_OUTPUT(HausdorffDistancePointSetFilter,HausdorffDistance,"Hausdorff distance",double,"");
  
  BBTK_OUTPUT(HausdorffDistancePointSetFilter,OutA,"Output Mesh with 'Distance' vector information",vtkPolyData*,"");
  BBTK_OUTPUT(HausdorffDistancePointSetFilter,OutB,"Output Mesh with 'Distance' vector information",vtkPolyData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(HausdorffDistancePointSetFilter);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbcreaVtk

#endif // __bbcreaVtkHausdorffDistancePointSetFilter_h_INCLUDED__

