//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkLightKit.h"
#include "bbcreaVtkPackage.h"

//#include <vtkLight.h>
#include <vtkLightCollection.h>
#include <vtkLightKit.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,LightKit)
BBTK_BLACK_BOX_IMPLEMENTATION(LightKit,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LightKit::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
	vtkLightCollection* originalLights = bbGetInputRenderer()->GetLights();
	std::cout << "Now there are " << originalLights->GetNumberOfItems() << " lights." << std::endl;

	if (firsttime==true)
	{
		firsttime=false;
		bbGetInputRenderer()->RemoveAllLights();
		vtkLightKit *lightKit=vtkLightKit::New();
		//bbGetInputRenderer()->SetTwoSidedLighting(0);
		lightKit->SetKeyLightWarmth( bbGetInputKeyLightWarmth() );
		lightKit->SetFillLightWarmth( bbGetInputFillLightWarmth() );
		lightKit->SetBackLightWarmth( bbGetInputBackLightWarmth() );
		lightKit->AddLightsToRenderer( bbGetInputRenderer() );
	}

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LightKit::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputRenderer(NULL);
   bbSetInputKeyLightWarmth(0.8);
   bbSetInputFillLightWarmth(5.0);
   bbSetInputBackLightWarmth(0.5);
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LightKit::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void LightKit::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


