//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkReadMHDPlane.h"
#include "bbcreaVtkPackage.h"

#include "stdio.h"


#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <sys/types.h>

#if defined(_WIN32)
	#include <share.h> 
#else
	#include <unistd.h>
#endif // defined(_WIN32)

#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,ReadMHDPlane)
BBTK_BLACK_BOX_IMPLEMENTATION(ReadMHDPlane,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 


vtkImageData* ReadMHDPlane::CreateDefaultImage()
{
	vtkImageData *newImage = NULL;
/*
	newImage = vtkImageData::New();
	int i;
	int sizeX, sizeY, sizeZ;
	sizeX = 1;
	sizeY = sizeX;
	sizeZ = 1;
	vtkImageData *newImage = vtkImageData::New();
   	newImage->Initialize();
   	newImage->SetSpacing( 1,1,1 );
   	newImage->SetDimensions(  sizeX,sizeY,sizeZ );
   	newImage->SetExtent(0,  sizeX-1,0,sizeY-1,0,sizeZ-1 );	
//EED 2017-01-01 Migration VTK7
#if VTK_MAJOR_VERSION <= 5
   	newImage->SetWholeExtent(0,  sizeX-1,0,sizeY-1,0,sizeZ-1 );
   	newImage->SetScalarTypeToUnsignedChar();
   	newImage->SetNumberOfScalarComponents(1);
   	newImage->AllocateScalars();
   	newImage->Update();
#else
//   	newImage->AllocateScalars(VTK_UNSIGNED_CHAR,1);
   	newImage->AllocateScalars(VTK_SHORT,1);
#endif
//	memset ( (void*)newImage->GetScalarPointer(), 0, sizeX*sizeY*sizeZ*sizeof(unsigned char) );
	memset ( (void*)newImage->GetScalarPointer(), 0, sizeX*sizeY*sizeof(short) );
//   	for (i=0; i<sizeX; i++)
//   	{
//		newImage->SetScalarComponentFromDouble(i,i			,0, 0, 255 );
//		newImage->SetScalarComponentFromDouble(i,sizeY-1-i	,0, 0, 255 );
//  	} // for i
   	newImage->Modified();
*/
	return newImage;
} 

vtkImageData* ReadMHDPlane::ChangeOrientation(vtkImageData* imgOrg)
{
	vtkImageData *imgDst  = NULL;

	if (imgOrg!=NULL)
	{
		int 	width;
		int 	ext[6];
		int 	sizeXOrg, sizeYOrg,sizeZOrg;
		int 	sizeXDst, sizeYDst,sizeZDst;
	//EED 2017-01-01 Migration VTK7
	#if VTK_MAJOR_VERSION <= 5
		imgOrg->GetWholeExtent(ext);
	#else
		imgOrg->GetExtent(ext);
	#endif
		int 	sizeLine;
		
		sizeXOrg 	= ext[1]-ext[0]+1;
		sizeYOrg 	= ext[3]-ext[2]+1;
		sizeZOrg 	= ext[5]-ext[4]+1;
	width=sizeZOrg;

		if (bbGetInputDirectionPlane()=="XY")
		{
			sizeXDst 	= ext[1]-ext[0]+1;
			sizeYDst 	= ext[3]-ext[2]+1;
			sizeZDst	= width;
		} // XY 
		if (bbGetInputDirectionPlane()=="YZ") 
		{
			sizeXDst 	= width;
			sizeYDst 	= ext[1]-ext[0]+1;
			sizeZDst 	= ext[3]-ext[2]+1;
			sizeLine 	= sizeYDst;
		} // YZ
		if (bbGetInputDirectionPlane()=="ZX")
		{
			sizeXDst 	= ext[1]-ext[0]+1;
			sizeYDst 	= width;
			sizeZDst 	= ext[3]-ext[2]+1;
			sizeLine 	= sizeXDst;
		} // ZX
		imgDst  = vtkImageData::New();
		imgDst->Initialize();
		imgDst->SetSpacing( imgOrg->GetSpacing() );
	   	imgDst->SetDimensions( sizeXDst,sizeYDst,sizeZDst );
	   	imgDst->SetExtent(0,sizeXDst-1,0,sizeYDst-1,0,sizeZDst-1 );
		
	//EED 2017-01-01 Migration VTK7
	#if VTK_MAJOR_VERSION <= 5
	   	imgDst->SetWholeExtent(0,sizeXDst-1,0,sizeYDst-1,0,sizeZDst-1 );
		imgDst->SetScalarType( imgOrg->GetScalarType() );
	   	imgDst->SetNumberOfScalarComponents(1);
	   	imgDst->AllocateScalars();
	   	imgDst->Update();
	#else
	   	imgDst->AllocateScalars(imgOrg->GetScalarType(),1);
	#endif

		char *ptrDst,*ptrOrg;
		int sizeBytes = imgOrg->GetScalarSize();		
		int sizeLineBytes = sizeLine*imgOrg->GetScalarSize();		
		int xx,yy,zz;

		long int sizeXDstBytes 		= sizeXDst*sizeBytes;
		long int sizeXYDstBytes		= sizeXDst*sizeYDst*sizeBytes;
		long int sizeXYDstBytes2	= sizeXDst*sizeYDst*sizeBytes*2;
		long int sizeXYZDstBytes	= sizeXDst*sizeYDst*sizeZDst*sizeBytes;
		long int sizeXYZDstBytes1	= sizeXDst*sizeYDst*(sizeZDst-1)*sizeBytes;

		ptrOrg = (char*)( imgOrg->GetScalarPointer() );

		if (bbGetInputDirectionPlane()=="XY")
		{
			memcpy ( imgDst->GetScalarPointer(), ptrOrg , sizeXDst*sizeYDst*sizeZDst*(imgOrg->GetScalarSize()) );
		} // if XY

		if (bbGetInputDirectionPlane()=="ZX")
		{
			ptrDst = (char*)( imgDst->GetScalarPointer(0,0,sizeYOrg-00-1) );
			for( zz=0 ; zz<sizeZOrg ; zz++)
			{
	//			ptrDst=(char*)( imgDst->GetScalarPointer(0,zz,sizeYOrg-00-1) );
				for( yy=0 ; yy<sizeYOrg ; yy++)
				{
	//				ptrOrg=(char*)( imgOrg->GetScalarPointer(0,yy,zz) );
	//				ptrDst=(char*)( imgDst->GetScalarPointer(0,zz,sizeYOrg-yy-1) );
					memcpy ( ptrDst, ptrOrg , sizeLineBytes );
					ptrOrg = ptrOrg + sizeLineBytes;
					ptrDst = ptrDst - sizeXYDstBytes;
				} // for yy 
				ptrDst = ptrDst + sizeXDstBytes;
				ptrDst = ptrDst + sizeXYZDstBytes;
			} // for zz 
		} // ZX

		if (bbGetInputDirectionPlane()=="YZ")
		{
			ptrDst = (char*)( imgDst->GetScalarPointer(0,0,sizeYOrg-0-1) );
			for( zz=0 ; zz<sizeZOrg ; zz++)
			{
				ptrDst=(char*)( imgDst->GetScalarPointer(zz,0,sizeYOrg-0-1) );
				for( yy=0 ; yy<sizeYOrg ; yy++)
				{
	//				ptrDst=(char*)( imgDst->GetScalarPointer(zz,0,sizeYOrg-yy-1) );
					for( xx=0 ; xx<sizeXOrg ; xx++)
					{
	//					ptrOrg=(char*)( imgOrg->GetScalarPointer(xx,yy,zz) );
	//					ptrDst=(char*)( imgDst->GetScalarPointer(zz,xx,sizeYOrg-yy-1) );
						memcpy ( ptrDst, ptrOrg , sizeBytes );
						ptrOrg+= sizeBytes;
						ptrDst+= sizeXDstBytes;
					} /// for xx
					ptrDst = ptrDst - sizeXYDstBytes2;
				} // for yy 
				ptrDst = ptrDst + sizeXYZDstBytes;
	//			ptrDst++;
			} // for zz 
		} // ZX
	} // if imgOrg
	return imgDst;
}

void ReadMHDPlane::Read64lseek(std::string fileNameIn, std::string plane)
{
	int 		imageType;
	int 		slice;
	int 		width;
	width = bbGetInputWidth();
	if (width<=0 ) { width=1; }
	slice = bbGetInputSlice();
	if (slice<0 ) { slice=0; }
	int 		dimX=-1,dimY=-1,dimZ=-1;
	int 		dim=-1;
	std::string formattype("VOID");
	std::string elementdatafile("VOID");
	float	 	spcX=-1,spcY=-1,spcZ=-1;
	float 		ox=-1,oy=-1,oz=-1;
	long int 	headersize=0;
	vtkImageData *newImage=NULL;
	char mystring[250];
	char strTmp[250];
	char strTmp2[250];
	FILE *ffIn	= fopen( fileNameIn.c_str() , "r");
	long long dataSize;
	if (ffIn!=NULL)
	{
		newImage = vtkImageData::New();
		while(!feof(ffIn))
		{
    	    strcpy(mystring,"\n");
   			fgets(mystring,250,ffIn);
   	     	if (strncmp("NDims",mystring,5)==0) 							{ sscanf(mystring,"%s %s %d"		,strTmp, strTmp, &dim); 								}
        	if (strncmp("DimSize",mystring,6)==0) 							{ sscanf(mystring,"%s %s %d %d %d"	,strTmp, strTmp, &dimX, &dimY,&dimZ);					} 
			if (strncmp("ElementType",mystring,11)==0) 						{ sscanf(mystring,"%s %s %s"		,strTmp, strTmp, strTmp2); formattype=strTmp2;			}
			if (strncmp("ElementSpacing",mystring,14)==0) 					{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);					}
			if (strncmp("ElementSize",mystring,11)==0) 						{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);					}
         	if (strncmp("Offset",mystring,6)==0) 							{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &ox, &oy, &oz);						}
        	if (strncmp("HeaderSize",mystring,10)==0) 						{ sscanf(mystring,"%s %s %ld"		,strTmp, strTmp, &headersize);							}
			if (strncmp("ElementDataFile",mystring,15)==0) 					{ sscanf(mystring,"%s %s %s"		,strTmp, strTmp, strTmp2); elementdatafile=strTmp2;		}
        	if (strncmp("ElementType = MET_CHAR",mystring,22)==0) 			{ imageType=VTK_CHAR; 			dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = VTK_CHAR",mystring,22)==0) 			{ imageType=VTK_CHAR; 			dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = MET_UCHAR",mystring,23)==0) 			{ imageType=VTK_UNSIGNED_CHAR;	dataSize=sizeof(unsigned char); }
        	if (strncmp("ElementType = VTK_UNSIGNED_CHAR",mystring,31)==0) 	{ imageType=VTK_UNSIGNED_CHAR;	dataSize=sizeof(unsigned char); }
        	if (strncmp("ElementType = MET_USHORT",mystring,24)==0) 		{ imageType=VTK_UNSIGNED_SHORT;	dataSize=sizeof(unsigned short);}
        	if (strncmp("ElementType = VTK_UNSIGNED_SHORT",mystring,32)==0) { imageType=VTK_UNSIGNED_SHORT;	dataSize=sizeof(unsigned short);}
        	if (strncmp("ElementType = MET_SHORT",mystring,23)==0) 			{ imageType=VTK_SHORT;			dataSize=sizeof(short); 		}
        	if (strncmp("ElementType = VTK_SHORT",mystring,23)==0) 			{ imageType=VTK_SHORT;			dataSize=sizeof(short); 		}
        	if (strncmp("ElementType = MET_UINT",mystring,22)==0) 			{ imageType=VTK_UNSIGNED_INT;	dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = VTK_UNSIGNED_INT",mystring,30)==0) 	{ imageType=VTK_UNSIGNED_INT;	dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = MET_INT",mystring,21)==0) 			{ imageType=VTK_INT;			dataSize=sizeof(int);			}
        	if (strncmp("ElementType = VTK_INT",mystring,21)==0) 			{ imageType=VTK_INT;			dataSize=sizeof(int);			}
        	if (strncmp("ElementType = MET_FLOAT",mystring,23)==0) 			{ imageType=VTK_FLOAT;			dataSize=sizeof(float); 		}
        	if (strncmp("ElementType = VTK_FLOAT",mystring,23)==0) 			{ imageType=VTK_FLOAT;			dataSize=sizeof(float); 		}
        	if (strncmp("ElementType = MET_LONG",mystring,22)==0) 			{ imageType=VTK_LONG;			dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = VTK_LONG",mystring,22)==0) 			{ imageType=VTK_LONG;			dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = MET_DOUBLE",mystring,24)==0) 		{ imageType=VTK_DOUBLE;			dataSize=sizeof(double); 		}
        	if (strncmp("ElementType = VTK_DOUBLE",mystring,24)==0) 		{ imageType=VTK_DOUBLE;			dataSize=sizeof(double); 		}
    	} // while
   		fclose(ffIn);
   		newImage->Initialize();
		int 		fd;
		long long 	ret;
		std::size_t found;
		std::string filename;
		found					= fileNameIn.find_last_of("/\\");
		filename 				= fileNameIn.substr(0,found+1) + elementdatafile ;
		long long 	pos;
		long long lsize			= dimX*dimY*width *dataSize;
#if defined(_WIN32)
            _sopen_s( &fd, filename.c_str(), _O_RDONLY, _SH_DENYNO, 0 );
#else
        //EED2021-09-03
        #if defined(MACOSX)
            fd = open ( filename.c_str() ,  O_RDONLY );
        #else
            fd = open ( filename.c_str() ,  O_RDONLY|O_LARGEFILE );
        #endif
#endif // defined(_WIN32)
		if (fd < 0)
		{
			printf("EED ReadMHDPlane::Read64lseek   WARNNING! raw file not exist\n");
			fprintf(stderr, "%s\n", strerror(errno));
			newImage=CreateDefaultImage();
//			exit(1);
		} 	
		if ((plane=="XY") && (fd>=0)) 
		{ 
	   		newImage->SetSpacing( spcX,spcY,spcZ );
	   		newImage->SetDimensions(  dimX,dimY,width );
	   		newImage->SetExtent(0,  dimX-1,0,dimY-1,0,width-1 );



//EED 2017-01-01 Migration VTK7
#if VTK_MAJOR_VERSION <= 5
			newImage->SetScalarType( imageType );
	   		newImage->SetWholeExtent(0,  dimX-1,0,dimY-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
#else
	   	newImage->AllocateScalars(imageType,1);
#endif	
			
			pos = dimX*dimY*(long long)slice*dataSize;
#if defined(_WIN32)
			if (_lseeki64( fd, pos, SEEK_SET ) < 0)
#else
            //EED2021-09-03
            #if defined(MACOSX)
                if (lseek(fd, pos, SEEK_SET) < 0)
            #else
                if (lseek64(fd, pos, SEEK_SET) < 0)
            #endif
#endif // defined(_WIN32)
			{
				printf("EED ReadMHDPlane::Read64lseek \n");
				fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
				exit(1);
			}
			if ((ret = read(fd, newImage->GetScalarPointer() , lsize)) < 0) 
			{
				fprintf(stderr, "Failed reading: %s\n", strerror(errno));
				exit(1);
			}
		}  // if PLANE XY
		if ((plane=="ZX") && (fd>=0))
		{ 
	   		newImage->SetSpacing( spcX,spcZ,spcY );
	   		newImage->SetDimensions(  dimX,dimZ,width );
	   		newImage->SetExtent(0,  dimX-1,0,dimZ-1,0,width-1 );
			

//EED 2017-01-01 Migration VTK7
#if VTK_MAJOR_VERSION <= 5
			newImage->SetScalarType( imageType );
	   		newImage->SetWholeExtent(0,  dimX-1,0,dimZ-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
#else
			newImage->AllocateScalars(imageType,1);
#endif	

			int iWidth;
			for (iWidth=0;iWidth<width;iWidth++)
			{
				copy_ZX_plane(fd,newImage,slice+iWidth,iWidth,dimX,dimY,dimZ,dataSize);
			}
		}  // if PLANE XZ
		if ((plane=="YZ") && (fd>=0))
		{ 
	   		newImage->SetSpacing( spcY,spcZ,spcX );
	   		newImage->SetDimensions(  dimY,dimZ,width );
	   		newImage->SetExtent(0,  dimY-1,0,dimZ-1,0,width-1 );
			
//EED 2017-01-01 Migration VTK7
#if VTK_MAJOR_VERSION <= 5
			newImage->SetScalarType( imageType );
	   		newImage->SetWholeExtent(0,  dimY-1,0,dimZ-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
#else
			newImage->AllocateScalars(imageType,1);
#endif	
			
			int iWidth;
			for (iWidth=0;iWidth<width;iWidth++)
			{
				copy_YZ_plane(fd,newImage,slice+iWidth,iWidth,dimX,dimY,dimZ,dataSize);
			}
		}  // if PLANE YZ	
#if defined(_WIN32)
		_close (fd);
#else
		close (fd);
#endif // defined(_WIN32)
	} else {
		newImage=CreateDefaultImage();
	} // if  ffIn
	bbSetOutputOut( newImage );
	bbSetOutputOut2( ChangeOrientation(newImage) );
}


void ReadMHDPlane::copy_YZ_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize)
{
	long long int j;
	long long int i;
	long long 	ret;
	long long 	pos;
	long long sizeBytesPlane = dimX*dimY*dataSize;
	char *pImage;
	for (j=0;j<dimZ;j++)
	{
		for (i=0;i<dimY;i++)
		{
			pos = ((long long int)slice+iWidth + i*dimX + j*dimX*dimY)*dataSize ;
#if defined(_WIN32)
			if (_lseeki64( fd, pos , SEEK_SET ) < 0)
#else
            //EED2021-09-03
            #if defined(MACOSX)
                if (lseek(fd, pos , SEEK_SET) < 0)
            #else
                if (lseek64(fd, pos , SEEK_SET) < 0)
            #endif
#endif // defined(_WIN32)
			{
				printf("EED ReadMHDPlane::Read64lseek \n");
				fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
				exit(1);
			}

			pImage=(char*)(newImage->GetScalarPointer(i, dimZ-1-j,iWidth ));
			if ((ret = read(fd, pImage , dataSize)) < 0) 
			{
				fprintf(stderr, "Failed reading: %s\n", strerror(errno));
				exit(1);
			}
			} // for i
		} // for j
}


void ReadMHDPlane::copy_ZX_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize)
{
	long long int j;
	long long 	ret;
	long long 	pos;
	pos = dimX*(long long int)slice*dataSize;
	long long sizeBytesPlane = dimX*dimY*dataSize;
	char *pImage = (char*)( newImage->GetScalarPointer(0,0,iWidth) );
	for (j=dimZ-1;j>=0;j--)
	{
#if defined(_WIN32)
		if (_lseeki64( fd, pos + j*sizeBytesPlane , SEEK_SET ) < 0)
#else
            //EED2021-09-03
            #if defined(MACOSX)
                if (lseek(fd, pos + j*sizeBytesPlane , SEEK_SET) < 0)
            #else
                if (lseek64(fd, pos + j*sizeBytesPlane , SEEK_SET) < 0)
            #endif
#endif // defined(_WIN32)
		{
			printf("EED ReadMHDPlane::Read64lseek \n");
			fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
			exit(1);
		}
		if ((ret = read(fd, pImage , dimX*dataSize)) < 0) 
		{
			fprintf(stderr, "Failed reading: %s\n", strerror(errno));
			exit(1);
		}
		pImage = pImage+dimX*dataSize;
	} // for j
}

void ReadMHDPlane::Process()
{
	if (bbGetInputActive()==true)
	{
		if (bbGetInputType()==0)
		{
			//-- Split FileName
			std::string inputfilename;
	  		std::size_t found		=	bbGetInputFileName().find_last_of("/\\");
			std::string path		=	bbGetInputFileName().substr(0,found+1);
			std::string filename	=	bbGetInputFileName().substr(found+1);
	#ifdef _WIN32
			path=path+"YZ_ZX\\";
	#else
			path=path+"YZ_ZX/";
	#endif
			if (bbGetInputDirectionPlane()=="XY") { inputfilename = bbGetInputFileName(); 		} // if XY
			if (bbGetInputDirectionPlane()=="YZ") { inputfilename = path+filename+"_YZ.mhd";  	} // if YZ
			if (bbGetInputDirectionPlane()=="ZX") { inputfilename = path+filename+"_ZX.mhd"; 	} // if XZ
			Read64lseek( inputfilename ,"XY");
		}	
		if (bbGetInputType()==1)
		{
			Read64lseek( bbGetInputFileName(), bbGetInputDirectionPlane() );
		}	
	} // if active
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputActive(true);
   bbSetInputFileName("");
   bbSetInputSlice(0);
   bbSetInputType(1);
   bbSetInputWidth(1);
   bbSetInputDirectionPlane("XY");
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserInitializeProcessing()
{
//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserFinalizeProcessing()
{
//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any 
}

} // EO namespace bbcreaVtk


